<?

class TreeComponent extends FormComponent {
 var $displayTypes;
 var $linkedTypes;
 var $formName;
 var $selector;
 var $ds;
 var $customTreeNodes;
 var $openToSelected = false;
 var $contextMenuFunction = "";
 var $searchers;

 function TreeComponent($formName, $displayTypes = array(), $linkedTypes = array(), $dsTypes = array()) {
 node_class( "minialldatasource" );
 $this->formName = $formName;
 $this->displayTypes = $displayTypes;
 $this->linkedTypes = $linkedTypes;
 $this->ds = new MiniAllDatasource ($dsTypes);
 $this->ds->setColumn( "icon", i18n("Contained"), true, true );
 $this->ds->setColumn( "type", i18n("Type"), true, true );
 $this->ds->setColumn( "name", i18n( "Name" ), true, true );
 $this->ds->setColumn( "folderpath", i18n("Folder"), true, true);
 $this->ds->setColumn( "masterNode", i18n("Master"), true, true);
 $this->ds->setColumn( "language", i18n("Language"), true, true);
 $this->ds->showColumnHeader(true);
 }

 function getSerializeKey() {
 $ret =& parent::getSerializeKey();
 $ret["displayTypes"] = &array_node_serialize($this->displayTypes);
 $ret["linkedTypes"] = &array_node_serialize($this->linkedTypes);
 $ret["formname"] = &node_serialize($this->formName);
 $ret["selector"] = &node_serialize($this->selector);
 $ret["ds"] = &node_serialize($this->ds);
 $ret["customTreeNodes"] = &array_node_serialize($this->customTreeNodes);
 $ret["openToSelected"] = &node_serialize($this->openToSelected);
 $ret["contextMenuFunction"] = &node_serialize($this->contextMenuFunction);
 $ret["searchers"] = &array_node_serialize($this->searchers);
 return $ret;
 }

 function initFromSerializeKey( $key ) {
 parent::initFromSerializeKey($key);
 $this->displayTypes = &array_node_unserialize($key["displayTypes"]);
 $this->linkedTypes = &array_node_unserialize($key["linkedTypes"]);
 $this->formName = &node_unserialize($key["formname"]);
 $this->selector = &node_unserialize($key["selector"]);
 $this->ds = &node_unserialize($key["ds"]);
 $this->ds->setSelector(&$this->selector);
 $this->customTreeNodes = &array_node_unserialize($key["customTreeNodes"]);
 $this->openToSelected = &node_unserialize($key["openToSelected"]);
 $this->contextMenuFunction = &node_unserialize($key["contextMenuFunction"]);
 $this->searchers = &array_node_unserialize($key["searchers"]);
 $this->ds->setSearchers($this->searchers);
 }

 function setContextMenuFunction($contextMenuFunction) {
 $this->contextMenuFunction = $contextMenuFunction;
 }

 function setCustomTreeNodes($customTreeNodes) {
 $this->customTreeNodes = $customTreeNodes;
 }

 function setSearchers($searchers) {
 $this->searchers = $searchers;
 $this->ds->setSearchers($searchers);
 }

 function setSelector(&$selector) {
 $this->selector =& $selector;
 $this->ds->setSelector(&$selector);
 }

 function getFields() {
 return array_merge(parent::getFields(), array("id" => "id of the clicked node","type" => "type of the clicked Node", "selid" => "id of the selected node", "cmd" => "action for the selected node"));
 }

 function _modifyColumns($ttype) {
 global $NODE_ID;

 
 $this->ds->hideColumn('masterNode');
 if ($NODE_ID) {
 $nodeinfo = get_nodeinfo($NODE_ID);
 if ($nodeinfo["master_id"]) {
 $this->ds->showColumn('masterNode');
 }
 }

 
 $this->ds->hideColumn('folderpath');
 $this->ds->hideColumn('language');
 $this->ds->hideColumn('type');

 
 switch ($ttype) {
 case T_DOMAIN:
 case T_FOLDER:
 case T_DOMAIN_CHANNEL:
 case T_FOLDER_CHANNEL:
 
 $this->ds->showColumn('type');
 $this->ds->showColumn('language');
 break;
 case 100010007:
 
 $this->ds->showColumn('folderpath');
 $this->ds->showColumn('language');
 break;
 case 100010002:
 case 100010008:
 case 100010011:
 
 $this->ds->showColumn('folderpath');
 break;
 case 12:
 case 14:
 case 10003:
 
 $this->ds->showColumn('type');
 break;
 }
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 global $DO, $STAG;

 
 $listId = $this->getFieldValue("id");
 $listType = $this->getFieldValue("type");

 $this->_modifyColumns($listType);

 if ($listId && $listType) {
 $list = new ItemList3("${fieldPrefix}list", $this->ds);
 $list->setResizable(false);
 }

 
 if ($this->selector) {
 $this->selector->subselectFolders();
 }

 $out = "<table><tr valign=\"top\"><td>";
 $t = new tree("", "${fieldPrefix}posidx");
 $t->openvar = "${fieldPrefix}flappi";
 $t->treelink = "$STAG&amp;do=$DO&amp;s".$this->formName."=1";
 $t->setDisplayTypes($this->displayTypes);
 if ($this->contextMenuFunction) {
 $t->show_context_menu = true;
 }
 
 if ($this->customTreeNodes) {
 reset ($this->customTreeNodes);
 while (list($key, $type) = each($this->customTreeNodes)) {
 $t->type[$key] = $type; 
 }
 }
 reset($this->displayTypes);
 while (list($key, $type) = each($this->displayTypes)) {
 $selectable = $this->selector && $this->selector->isSelectableType($type, true);
 $excludable = $this->selector && $this->selector->isExcludableType($type);
 if (!$selectable && !$excludable) {
 $t->type[$type]["allowlink"] = false;
 } else {
 $t->type[$type]["allowlink"] = true;
 $t->type[$type]["linktarget"] = "_self";
 $t->type[$type]["link"] = "do=$DO&amp;s".$this->formName."=1&amp;${fieldPrefix}type=$type&NODE_ID={\$rowval['node_id']}";
 if ($this->contextMenuFunction) {
 $t->type[$type]["context"] = "node_func(".$this->contextMenuFunction.", true, \$nid, \$itype, \$ntype, '${fieldPrefix}selid', '${fieldPrefix}cmd', '$STAG&amp;do=$DO&amp;s".$this->formName."=1',".($selectable ? "true" : "false").",".($excludable ? "true" : "false").", \$rowval['node_id'])";
 }
 }
 }
 reset($this->linkedTypes);
 while (list($key, $type) = each($this->linkedTypes)) {
 $t->type[$type]["allowlink"] = true;
 $t->type[$type]["linktarget"] = "_self";
 $t->type[$type]["linkvar"] = $fieldPrefix."id";
 $t->type[$type]["link"] = "do=$DO&amp;s".$this->formName."=1&amp;${fieldPrefix}type=$type&NODE_ID={\$rowval['node_id']}";
 }
 if ($this->selector) {
 node_class("selectortreenodeformatter");
 $t->setTreeNodeFormatter(new SelectorTreeNodeFormatter("${fieldPrefix}selid", "$STAG&amp;do=$DO&amp;s".$this->formName."=1", &$this->selector));
 }

 
 if (is_array($this->openToSelected)) {
 reset($this->openToSelected);
 while (list($key, $value) = each($this->openToSelected)) {
 if (in_array($value[0], $this->displayTypes)) {
 $t->opentree($value[0], $value[1]);
 }
 }
 $this->openToSelected = false;
 }

 $out .= $t->walktree(0, false, 0, $T_TYPE);
 $out .= "</td>";

 if ($listId && $listType) {
 $this->ds->setFolderID($listId);
 $this->ds->setFolderType($listType);
 $this->ds->setBaseLink("$STAG&amp;do=$DO&amp;s".$this->formName."=1&amp;${fieldPrefix}selid=");

 if (method_exists($this->ds, "initItemList")) {
 $this->ds->initItemList($list);
 }

 
 $selections = array('unselected', 'selected', 'autoselected', 'subselected', 'excluded', 'autoexcluded');
 $filter = array();
 
 foreach($selections as $sel) {
 $filter[$sel] = array('label' => i18n("export_$sel"), 'icon' => "$STAG_PREFIX?do=11&module=system&img=check_$sel.png", 'text' => i18n("export_".$sel."_short"));
 }
 $this->ds->setColumnFilter('icon', $filter);

 $list->setParentForm($this->formName);
 $out .= "<td>&nbsp;&nbsp;</td><td>";
 $out .= $list->getHTMLOutput();
 $out .= "</td>";
 }

 $out .= "</tr></table>\n";
 return $out;
 }

 function onLoadFinished() {
 $selid = $this->getFieldValue("selid");
 $action = $this->getFieldValue("cmd");
 if ($selid && $this->selector) {
 switch ($action) {
 case "select":
 $this->selector->select($selid);
 break;
 case "exclude":
 $this->selector->exclude($selid);
 break;
 case "unselect":
 $this->selector->unselect($selid);
 break;
 default:
 $this->selector->toggle($selid);
 break;
 }
 $this->setFieldValue("selid", null);
 $this->setFieldValue("cmd", null);
 }
 }

 function openToSelected($openToSelected) {
 $this->openToSelected = $openToSelected;
 }

 function addAction( &$itemListAction ) {
 $this->ds->addAction(&$itemListAction);
 }
}
?>
